import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Goat here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Goat extends SpriteSheet {
    private GreenfootImage stand = new GreenfootImage("GoatStand.png");
    private GreenfootImage walk = new GreenfootImage("GoatWalk.png");
    private int index = 0;
    private int delay = 0;
    private double[] loc;
    
    public boolean flip = false;
    public double[] velocity = {0, 0};
    public boolean inAir = false;
    
    public void addedToWorld(World world) {
        loc = new double[] {getX(), getY()};
        act();
    }
    
    public void act() {
        if(Greenfoot.isKeyDown("a")) {
            velocity[0] = -5;
            if(flip) flip = false;
        } else if(Greenfoot.isKeyDown("d")) {
            velocity[0] = 5;
            if(!flip) flip = true;
        }
        
        if(Greenfoot.isKeyDown("space") && loc[1] >= getWorld().getHeight()-getImage().getHeight()/2) velocity[1] = -15;
        
        if(loc[1] > getWorld().getHeight()-getImage().getHeight()/2) loc[1] = getWorld().getHeight()-getImage().getHeight()/2;
        
        loc[0] += velocity[0];
        loc[1] += velocity[1];
        
        setLocation((int)loc[0], (int)loc[1]);
        
        if(loc[1] < getWorld().getHeight()-getImage().getHeight()/2) {
            velocity[1]++;
            if(flip) turn(10);
            else turn(-10);
            inAir = true;
        } else {
            velocity[1] = 0;
            setRotation(0);
            inAir = false;
        }
        if(velocity[0] > 0) velocity[0]-=0.125;
        else if(velocity[0] < 0) velocity[0]+=0.125;
        
        if(delay==0) {
            index++;
            index %= 8;
            delay = 6;
        } else {
            delay--;
        }
        updateImage();
    }
    
    public void updateImage() {
        if(Greenfoot.isKeyDown("a") || Greenfoot.isKeyDown("d")) setImage(getSprite(walk, index, (walk.getWidth()-20)/8, walk.getHeight()));
        else setImage(getSprite(stand, index, stand.getWidth()/8, stand.getHeight()));
        if(flip) getImage().mirrorHorizontally();
    }
}
